## libvigraimpex 1.10.0+git20160211.167be93+dfsg

=== docsrc/CMakeLists.txt ===
IF(DOXYGEN_FOUND AND PYTHONINTERP_FOUND)
    execute_process(COMMAND ${DOXYGEN_EXECUTABLE} --version
                  OUTPUT_VARIABLE DOXYGEN_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)

    if(DOXYGEN_VERSION VERSION_LESS 1.8)
        set(DOXYGEN_BEFORE_1_8 "")
        set(DOXYGEN_FROM_1_8_2 "#")
    elseif(DOXYGEN_VERSION VERSION_LESS 1.8.2)
        set(DOXYGEN_BEFORE_1_8 "#")
        set(DOXYGEN_FROM_1_8_2 "#")
    else()
        set(DOXYGEN_BEFORE_1_8 "#")
        set(DOXYGEN_FROM_1_8_2 "")
    endif()
    
    CONFIGURE_FILE(
        ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
        ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        @ONLY)

    ADD_CUSTOM_TARGET (doc_cpp
        COMMAND ${CMAKE_COMMAND} -E make_directory ${DOCDIR}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${DOCDIR}/vigra
        COMMAND ${DOXYGEN_EXECUTABLE}  
        COMMENT "Generating documentation with doxygen ${DOXYGEN_VERSION}")

    ADD_CUSTOM_COMMAND(
        TARGET doc_cpp
        POST_BUILD
        COMMAND ${PYTHON_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/makeFunctionIndex.py
            ${DOCDIR}/vigra
        COMMAND ${PYTHON_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/post.py
            ${DOCDIR}/vigra
            ${vigra_version}
        COMMAND ${CMAKE_COMMAND} -E copy_directory
            ${CMAKE_CURRENT_SOURCE_DIR}/documents
            ${DOCDIR}/vigra/documents
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
            ${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE.txt
            ${DOCDIR}/vigra/LICENSE.txt
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
            ${CMAKE_CURRENT_SOURCE_DIR}/../src/matlab/doc/tutorial_reference.pdf
            ${DOCDIR}/vigra/documents/tutorial_reference.pdf
        COMMENT "Postprocessing html files")

ELSE()
    ADD_CUSTOM_TARGET (doc_cpp 
        COMMAND ${CMAKE_COMMAND} -E echo
            \"Cannot generate C++ documentation -- doxygen or Python not found.\")

ENDIF()

# create fallback index.html that simply refers to the online documentation
file(MAKE_DIRECTORY ${DOCDIR}/vigra)
file(GLOB INDEX_HTML_EXISTS ${DOCDIR}/vigra/index.html)
configure_file(vigra-icon.ico ${DOCDIR}/vigra/vigra-icon.ico COPYONLY)
if(NOT INDEX_HTML_EXISTS)
    configure_file(index_fallback.html ${DOCDIR}/vigra/index.html COPYONLY)
    configure_file(vigra.css ${DOCDIR}/vigra/vigra.css COPYONLY)
endif()

INSTALL(DIRECTORY ${DOCDIR}/
         DESTINATION ${DOCINSTALL}/)

ADD_DEPENDENCIES(doc doc_cpp)

=== test/classifier/CMakeLists.txt ===
if(HDF5_FOUND)
    INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
  
    ADD_DEFINITIONS(${HDF5_CPPFLAGS} -DHasHDF5)
    VIGRA_ADD_TEST(test_classifier test.cxx LIBRARIES vigraimpex ${HDF5_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: test_classifier::RFHDF5Test() will not be executed")
    VIGRA_ADD_TEST(test_classifier test.cxx )
endif()

VIGRA_ADD_TEST(classifier_speed_comparison speed_comparison.cxx)

add_subdirectory(data)

=== test/coordinateiterator/CMakeLists.txt ===
VIGRA_ADD_TEST(test_coordinateiterator test.cxx)

=== test/correlation/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${FFTW3_INCLUDE_DIR})

    VIGRA_CONFIGURE_THREADING()

    VIGRA_ADD_TEST(test_correlation test.cxx LIBRARIES ${FFTW3_LIBRARIES} ${FFTW3F_LIBRARIES} ${THREADING_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: fftw not found. test_correlation will not be executed")
endif()

=== test/counting_iterator/CMakeLists.txt ===
VIGRA_ADD_TEST(test_counting_iterator test.cxx)

=== test/delegates/CMakeLists.txt ===
VIGRA_ADD_TEST(test_delegates test.cxx)

=== test/hdf5impex/CMakeLists.txt ===
if(HDF5_FOUND)
    INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
  
    ADD_DEFINITIONS(${HDF5_CPPFLAGS})

    VIGRA_ADD_TEST(test_hdf5impex test.cxx LIBRARIES vigraimpex ${HDF5_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: test_hdf5impex will not be executed")
endif()

=== test/impex/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
ENDIF(OPENEXR_FOUND)

VIGRA_ADD_TEST(test_impex test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(lenna.xv lenna_gifref.xv lennafloat.xv lennafloatrgb.xv lennargb.xv no-image.txt lenna_0.tif lenna_1.tif lenna_2.tif lenna_masked_color.tif  lenna_masked_gray.tif bilevel.tiff)

=== test/integral_image/CMakeLists.txt ===

VIGRA_ADD_TEST(test_integral_image test.cxx LIBRARIES vigraimpex)

=== test/objectfeatures/CMakeLists.txt ===
VIGRA_ADD_TEST(test_objectfeatures test.cxx LIBRARIES vigraimpex)
VIGRA_ADD_TEST(test_stand_alone_acc_chain stand_alone_acc_chain.cxx)
VIGRA_COPY_TEST_DATA(of.gif)

=== test/registration/CMakeLists.txt ===
VIGRA_CONFIGURE_THREADING()

if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${FFTW3_INCLUDE_DIR})
    ADD_DEFINITIONS(-DHasFFTW3)

    VIGRA_ADD_TEST(test_registration test.cxx LIBRARIES ${FFTW3_LIBRARIES} ${FFTW3F_LIBRARIES} ${THREADING_LIBRARIES} vigraimpex)
else()
    MESSAGE(STATUS "** WARNING: fftw not found. Fourier-domain registration tests will not be executed")

    VIGRA_ADD_TEST(test_registration test.cxx LIBRARIES ${THREADING_LIBRARIES} vigraimpex)
endif()

VIGRA_COPY_TEST_DATA(nuernberg-1991.png nuernberg-1995.png)

=== test/unsupervised/CMakeLists.txt ===
VIGRA_ADD_TEST(test_unsupervised test.cxx)

# the data from 'example_data.h5' are now in 'test_data.hxx', so HDF5 is
# no longer needed for this test
# if(HDF5_FOUND)
    # INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
  
    # ADD_DEFINITIONS(${HDF5_CPPFLAGS})

    # VIGRA_ADD_TEST(test_unsupervised test.cxx LIBRARIES vigraimpex ${HDF5_LIBRARIES})
    
    # VIGRA_COPY_TEST_DATA(example_data.h5)
# else()
    # MESSAGE(STATUS "** WARNING: test_unsupervised will not be executed")
# endif()

=== debian/changelog ===
libvigraimpex (1.10.0+git20160211.167be93+dfsg-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New patch link-with-pthread.patch to fix FTBFS against boost1.67 on
    armel (Closes: #914649)

 -- Gilles Filippini <pini@debian.org>  Thu, 29 Nov 2018 20:39:23 +0100

libvigraimpex (1.10.0+git20160211.167be93+dfsg-6) unstable; urgency=medium

  * add multi_convolution_fix_incomplete_template_paramater.patch
    (Closes: #897800).
  * deb/changelog: remove a trailing whitespace.
  * deb/control: update Vcs fields (moved to salsa).
  * deb/copyright:
    + use HTTPS in Format field.
    + expand copyright span.
  * add deb/gbp.conf.

 -- Daniel Stender <stender@debian.org>  Sat, 11 Aug 2018 06:20:04 +0200

libvigraimpex (1.10.0+git20160211.167be93+dfsg-5) unstable; urgency=medium

  * deb/rules: build test_multiarray with -O0 (Closes: #872037).

 -- Daniel Stender <stender@debian.org>  Mon, 14 Aug 2017 22:40:53 +0200

libvigraimpex (1.10.0+git20160211.167be93+dfsg-4) unstable; urgency=medium

  * Upload to unstable.
  * deb/rules: add info on manipulation of test_gridgraph.

 -- Daniel Stender <stender@debian.org>  Sat, 12 Aug 2017 23:00:23 +0200

libvigraimpex (1.10.0+git20160211.167be93+dfsg-4~exp1) experimental; urgency=medium

  * const-swap.patch: provide DEP-3 header.
  * deb/control: update Homepage.
  * deb/rules:
    + change test_blockwiselabeling and test_blockwisewatersheds
      to build with -O0 (Closes: #853513) [thanks to Andreas Metzler].
    + apply the same change for test_gridgraph.
  * drop temporarily-disable-blockwisealgorithms-tests.patch (not needed
    anymore).

 -- Daniel Stender <stender@debian.org>  Thu, 10 Aug 2017 13:02:27 +0200

libvigraimpex (1.10.0+git20160211.167be93+dfsg-3) unstable; urgency=medium

  * add temporarily-disable-blockwisealgorithms-tests.patch.
  * add const-swap.patch (Closes: #871169) [thanks to Matthias Klose].
  * deb/copyright: add src/images/dissolved_color.gif to Files-Excluded
    (which contains "lenna" in composite).

 -- Daniel Stender <stender@debian.org>  Wed, 09 Aug 2017 00:41:15 +0200

libvigraimpex (1.10.0+git20160211.167be93+dfsg-2) unstable; urgency=medium

  * deb/rules: set ffloat-store for i386 CPUs (Closes: #820429)
    [thanks to Tobias Frost].

 -- Daniel Stender <stender@debian.org>  Mon, 18 Apr 2016 17:37:49 +0200

libvigraimpex (1.10.0+git20160211.167be93+dfsg-1) unstable; urgency=medium

  * Stripped non-free "lenna" images from source tarball (Closes: #794853):
    + added all image instances (inkl. Khoros Visualization images, .xv) to
      Files-Excluded in deb/copyright.
    + added disable-tests-which-would-need-lenna-images.diff.

 -- Daniel Stender <stender@debian.org>  Wed, 23 Mar 2016 21:12:41 +0100

libvigraimpex (1.10.0+git20160211.167be93-4) unstable; urgency=medium

  * Upload to unstable.
  * deb/changelog: merged with Sid.
  * deb/rules: build test/math with -O0 (Closes: #817840), cosmetics.

 -- Daniel Stender <stender@debian.org>  Sat, 12 Mar 2016 08:39:03 +0100

libvigraimpex (1.10.0+git20160211.167be93-3) experimental; urgency=medium

  * deb/rules: temporarily failsafe test/multiarray/test_multiarray_chunked
    to build on ppc64el.

 -- Daniel Stender <stender@debian.org>  Wed, 09 Mar 2016 21:45:05 +0100

libvigraimpex (1.10.0+git20160211.167be93-2) experimental; urgency=medium

  * deb/control: added missing Breaks for libvigraimpex6 (Closes: #815795).
  * Added fix-impex-positiontest.diff (Closes: #812850)
  * deb/rules:
    + build with Boost.Thread on armel (Closes: #814606) [plus, added
      libboost-thread-dev to build-deps in control; thanks to Ullrich Koethe].
    + dropped failsafe for test/impex (not needed anymore).
  * Updated uploader email address.

 -- Daniel Stender <stender@debian.org>  Tue, 01 Mar 2016 23:32:30 +0100

libvigraimpex (1.10.0+git20160211.167be93-1) experimental; urgency=medium

  [ Daniel Stender ]
  * Build libvigraimpex6 (Closes: #813415).
  * Add support for multiarch (Closes: #812560).
    + don't ship libvigraimpex-dev with old style vigra-config script.
  * deb/control:
    + depend libvigraimpex-dev on libpng-dev [thanks to Tobias Frost].
    + use HTTPS for Vcs fields.
    + bumped Standards-Version to 3.9.7 (no changes needed).
    + added Replaces to libvigraimpex6 [thanks to Andreas Metzler].
  * deb/copyright: expanded copyright span, added email address.
  * deb/rules:
    + added DH_VERBOSE export line.
    + add BINDNOW to linker flags.
    + don't build with -O3 on ppc64el (support for Ubuntu development).
    + dropped --keep-going from testsuite call to break immediately.
    + removed old, obsolete and unneeded stuff, cosmetics.
  * deb/clean: removed unneeded lines.
  * deb/README.Debian: corrected typo.
  * Dropped deb/libvigraimpex5v5.lintian-overrides.

  [ Andreas Metzler ]
  * Build with version-1-11-rc branch.
    + Unfuzz patches.
    + deb/control: version libboost-python-dev build-dependency.
    + deb/rules: tighten dh_makeshlibs -V argument.

 -- Daniel Stender <debian@danielstender.com>  Mon, 15 Feb 2016 02:43:41 +0100

libvigraimpex (1.10.0+git20160120.803d5d4-3) unstable; urgency=medium

  * deb/control: depend libvigraimpex-dev on libpng-dev.

 -- Daniel Stender <debian@danielstender.com>  Tue, 23 Feb 2016 15:25:11 +0100

libvigraimpex (1.10.0+git20160120.803d5d4-2) unstable; urgency=medium

  * Build libvigraimpex6 (Closes: #813415).

 -- Daniel Stender <debian@danielstender.com>  Sat, 20 Feb 2016 15:48:35 +0100

libvigraimpex (1.10.0+git20160120.803d5d4-1) unstable; urgency=medium

  * Packaging latest development snapshot (Closes: #811370).
  * deb/control:
    + needs python3-sphinx to build.
  * deb/rules:
    + failsafe test/impex temporarily due for problems with EXR.
  * Build with different upstream tarball (the flavour without doc/):
    + deb/watch: changed regex pattern for tarball, added repacksuffix.
    + dropped deb/get-orig.source.sh.


=== debian/control ===
Source: libvigraimpex
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Daniel Stender <stender@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9),
 dh-python,
 dpkg-dev (>= 1.15.3~),
 libboost-python-dev (>= 1.40.0),
 libfftw3-dev,
 libhdf5-dev (>= 1.8),
 libjpeg-dev,
 libopenexr-dev,
 libpng-dev,
 libtiff5-dev,
 python-all-dev,
 python-nose,
 python-numpy,
 libboost-thread-dev
Build-Depends-Indep:
 doxygen,
 ghostscript,
 python,
 python3-sphinx,
 texlive-latex-base
Build-Conflicts:
 autoconf2.13
X-Python-Version: >= 2.5
Standards-Version: 3.9.7
Vcs-Browser: https://salsa.debian.org/science-team/libvigraimpex
Vcs-Git: https://salsa.debian.org/science-team/libvigraimpex.git
Homepage: http://ukoethe.github.io/vigra/

Package: libvigraimpex-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libfftw3-dev,
 libhdf5-dev (>= 1.8),
 libjpeg-dev,
 libpng-dev,
 libtiff5-dev,
 libvigraimpex6 (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 libvigraimpex-doc
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Breaks:
 libvigraimpex5v5 (>= 1.10.0+git20160120.803d5d4-1)
Replaces:
 libvigraimpex5v5 (>= 1.10.0+git20160120.803d5d4-1)
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.

Package: libvigraimpex-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 libvigraimpex-dev,
 python-vigra-doc
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for the VIGRA library.

Package: python-vigra
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Recommends:
 python-qt4
Suggests:
 python-h5py,
 python-vigra-doc
Description: Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package exports the functionality of the VIGRA library to Python.

Package: python-vigra-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends}
Suggests:
 libvigraimpex-doc,
 python-vigra
Description: Documentation for Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for Python bindings for the VIGRA library.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
#export DEB_BUILD_OPTIONS=nocheck

CFLAGS := $(shell env DEB_CFLAGS_MAINT_APPEND=-pipe dpkg-buildflags --get CFLAGS; dpkg-buildflags --get CPPFLAGS)
CXXFLAGS := $(shell env DEB_CXXFLAGS_MAINT_APPEND=-pipe dpkg-buildflags --get CXXFLAGS; dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell env DEB_LDFLAGS_MAINT_APPEND='-Wl,--as-needed -Wl,-z,now' dpkg-buildflags --get LDFLAGS)

# support for Ubuntu development
ifeq ($(DEB_HOST_ARCH),ppc64el)
  CFLAGS := $(subst -O3,-O2,$(CFLAGS))
  CXXFLAGS := $(subst -O3,-O2,$(CXXFLAGS))
endif

# fixing floating-point rounding errors on i386 CPUs, see #820429
ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
  CFLAGS += -ffloat-store
  CXXFLAGS += -ffloat-store
endif

# build with Boost.Thread on armel, see #814606
ifeq ($(DEB_HOST_ARCH),armel)
  CMAKE_EXTRAS := -DWITH_BOOST_THREAD=1
  CXXFLAGS += -std=c++11 # not set by VigraDetectThreading.cmake
endif

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
  CXXFLAGS += --param ggc-min-expand=20
endif

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  export CMAKE_INCLUDE_PATH=/usr/include/hdf5/serial
  export CMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

cmake_options = \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)/" \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DWITH_OPENEXR=ON \
    -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
    -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
    -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
    $(CMAKE_EXTRAS)

cmake_python_options = \
    -DPYTHON_EXECUTABLE=/usr/bin/python$(1) \
    -DPYTHON_INCLUDE_DIR=/usr/include/python$(1)/ \
    -DPYTHON_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(1).so \
    -DBoost_PYTHON_LIBRARY_RELEASE=/usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python-py$(subst .,,$(1)).so

# build and build-* targets
# =========================

.PHONY: build
build: build-arch build-indep

.PHONY: build-indep
build-indep:

.PHONY: build-arch
build-arch:
	dh_testdir
	@echo DEBUGMEMSIZE ; if which free ; then free ; fi
	$(MAKE) -f debian/rules obj/CMakeCache.txt
	$(MAKE) -f debian/rules	$(patsubst %,obj.%/CMakeCache.txt,$(shell pyversions -r))
	$(MAKE) -f debian/rules obj/build-stamp
	$(MAKE) -f debian/rules $(patsubst %,obj.%/build-stamp,$(shell pyversions -r))
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	$(MAKE) -f debian/rules obj/test-stamp
	$(MAKE) -f debian/rules $(patsubst %,obj.%/test-stamp,$(shell pyversions -r))
endif

obj/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && cmake .. $(cmake_options) -DPYTHON_EXECUTABLE=/usr/bin/python -DWITH_VIGRANUMPY=0

obj.python%/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && CXXFLAGS=-fno-strict-aliasing cmake .. $(cmake_options) $(call cmake_python_options,$(*))
	find $(dir $(@))/vigranumpy/ -name 'link.txt' -exec sed -i \
		-e 's/ -lpython[0-9.]\+ / /g' -e '/-Wl,-soname,vigranumpycore/b' -e 's/ -Wl,-soname,[^ ]\+ / /' {} +

obj/build-stamp: obj/CMakeCache.txt
	$(MAKE) -C $(dir $(@))
	touch $(@)

obj.python%/build-stamp: obj.python%/CMakeCache.txt obj/build-stamp
	cd obj && find . -name '*.o' -o -name '*.so' -o -name '*.so.*' | xargs cp -v --preserve=links --parents -t ../$(dir $(@))
	$(MAKE) -C $(dir $(@))
	touch $(@)

obj/test-stamp: obj/build-stamp
	sed -i 's/exit\ 1/exit\ 0/' obj/test/multiarray/run_test_multiarray_chunked.sh #812852
	sed -i 's/-O2/-O0/' obj/test/math/CMakeFiles/test_math.dir/flags.make #817840
	sed -i 's/-O2/-O1/' obj/test/blockwisealgorithms/CMakeFiles/test_blockwiselabeling.dir/flags.make # https://github.com/ukoethe/vigra/issues/409
	sed -i 's/-O2/-O1/' obj/test/blockwisealgorithms/CMakeFiles/test_blockwisewatersheds.dir/flags.make # https://github.com/ukoethe/vigra/issues/409, #853513
	sed -i 's/-O2/-O1/' obj/test/gridgraph/CMakeFiles/test_gridgraph.dir/flags.make #871556
	sed -i 's/-O2/-O0/' obj/test/multiarray/CMakeFiles/test_multiarray.dir/flags.make #872037
	$(MAKE) check -C $(dir $(@))
	touch $(@)

obj.python%/test-stamp:: obj.python%/build-stamp
	$(MAKE) vigranumpytest -C $(dir $(@))
	touch $(@)

# binary and binary-* targets
# ===========================

.PHONY: binary
binary: binary-arch binary-indep

.PHONY: binary-arch
binary-arch: build-arch
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules obj/install-stamp
	$(MAKE) -f debian/rules $(patsubst %,obj.%/install-stamp,$(shell pyversions -r))
	dh_install -a
	dh_installdocs -a
	sh debian/convert-changelog.sh < docsrc/credits_changelog.dxx > doc/changelog
	dh_installchangelogs -a
	dh_installexamples -a
	dh_lintian -a
	dh_python2 -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_strip -a
	dh_makeshlibs -a -V 'libvigraimpex6 (>= 1.10.0+git20160211.167be93)'
	dh_shlibdeps -a
	dh_numpy -p python-vigra
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

%/install-stamp: %/build-stamp
	$(MAKE) -C $(dir $(@)) install DESTDIR=$(CURDIR)/debian/tmp/
	touch $(@)

.PHONY: binary-indep
binary-indep: build-indep
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules doc/vigra/build-stamp
	$(MAKE) -f debian/rules doc/vigranumpy/build-stamp
	dh_installdocs -i -XLICENSE.txt -Xobjects.inv -Xdoctrees -X.buildinfo -Xbuild-stamp
	cd debian/libvigraimpex-doc/usr/share/doc/libvigraimpex-doc/ && rm -rf html && mv vigra html && rm -f html/jquery.js && \
		sed -r -i -e 's!(<a href=")LICENSE.txt(">)!\1/usr/share/doc/libvigraimpex-doc/copyright\2!g' html/index.html
	cd debian/python-vigra-doc/usr/share/doc/python-vigra-doc/ && rm -rf html && mv vigranumpy html
	dh_installchangelogs -i
	dh_lintian -i
	dh_link -i
	dh_sphinxdoc -p python-vigra-doc
	dh_compress -i -X.js -X_sources
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

doc/vigra/build-stamp: obj/build-stamp
	$(MAKE) doc_cpp -C obj/
	touch $(@)

doc/vigranumpy/build-stamp: obj.$(shell pyversions -d)/build-stamp doc/vigra/build-stamp
	ln -sf $(CURDIR)/vigranumpy/docsrc/c_api_replaces.txt obj.$(shell pyversions -d)/vigranumpy/docsrc/
	$(MAKE) doc_python -C obj.$(shell pyversions -d)/
	touch $(@)

# clean target
# ============

.PHONY: clean
clean:
	dh_testdir
	dh_clean
	rm -rf obj*/
	rm -rf doc/

.NOTPARALLEL:

## libvigraimpex 1.10.0+git20160211.167be93+dfsg1

=== vigranumpy/CMakeLists.txt ===
IF(VIGRANUMPY_DEPENDENCIES_FOUND)
    ADD_CUSTOM_TARGET(vigranumpy)
    ADD_DEPENDENCIES(vigranumpy vigraimpex)

    SET(vigranumpy_tmp_dir "${CMAKE_BINARY_DIR}/vigranumpy/vigra")
    FILE(MAKE_DIRECTORY ${vigranumpy_tmp_dir})

    INCLUDE_DIRECTORIES(${VIGRANUMPY_INCLUDE_DIRS})

    IF(HDF5_FOUND)
        ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
        INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
        SET(VIGRANUMPY_IMPEX_LIBRARIES vigraimpex ${HDF5_LIBRARIES})
    ELSE()
        SET(VIGRANUMPY_IMPEX_LIBRARIES vigraimpex)
    ENDIF(HDF5_FOUND)

    IF(MSVC OR MINGW)
        ADD_DEFINITIONS(-DVIGRA_DLL)
    ENDIF ()

    include(VIGRA_ADD_NUMPY_MODULE)

    ADD_SUBDIRECTORY(src)
    ADD_SUBDIRECTORY(lib)
    ADD_SUBDIRECTORY(test)
    ADD_SUBDIRECTORY(docsrc)

    IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/private/CMakeLists.txt)
        ADD_SUBDIRECTORY(private EXCLUDE_FROM_ALL)
    ENDIF()

    IF(PYTHON_PLATFORM MATCHES "^windows$")
        FILE(MAKE_DIRECTORY ${vigranumpy_tmp_dir}/dlls)
        file(RELATIVE_PATH VIGRAIMPEX_DOCDIR ${vigranumpy_tmp_dir} ${DOCDIR})

        if(CMAKE_MAJOR_VERSION LESS 3)
            GET_TARGET_PROPERTY(VIGRAIMPEX_LOCATION vigraimpex LOCATION)
            CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.cmake2.in
                           ${CMAKE_CURRENT_BINARY_DIR}/setup.py
                           @ONLY)
        else()
            CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in
                           ${CMAKE_CURRENT_BINARY_DIR}/setup.py.in
                           @ONLY)

            # two-stage file configuration is necessary because certain target
            # properties are only known at generation time (policy CMP0026)
            file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/setup.py
                          INPUT  ${CMAKE_CURRENT_BINARY_DIR}/setup.py.in
                          CONDITION $<CONFIG:Release>)
        endif()

        add_custom_target(PACKAGE_VIGRANUMPY
                           COMMAND ${CMAKE_COMMAND} -E copy_directory ${DOCDIR} ${vigranumpy_tmp_dir}/doc
                           COMMAND python setup.py bdist_wininst
                           DEPENDS check
                           WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                           COMMENT "Creating vigranumpy setup in ${CMAKE_CURRENT_BINARY_DIR}/dist")
    ENDIF()

    set(VIGRANUMPY_CONFIG_INSTALL_PATH lib${LIB_SUFFIX}/vigranumpy)

    set(VIGRANUMPY_INCLUDE_RELATIVE "")
    foreach(PATH ${CMAKE_INSTALL_PREFIX}/include ${VIGRANUMPY_INCLUDE_DIRS})
        file(RELATIVE_PATH RELPATH ${CMAKE_INSTALL_PREFIX}/${VIGRANUMPY_CONFIG_INSTALL_PATH} ${PATH})
        set(VIGRANUMPY_INCLUDE_RELATIVE ${VIGRANUMPY_INCLUDE_RELATIVE} ${RELPATH})
    endforeach(PATH)

    set(VIGRANUMPY_LIBRARIES_RELATIVE "")
    foreach(PATH ${VIGRANUMPY_LIBRARIES})
        if(EXISTS ${PATH})
            file(RELATIVE_PATH RELPATH ${CMAKE_INSTALL_PREFIX}/${VIGRANUMPY_CONFIG_INSTALL_PATH} ${PATH})
            set(VIGRANUMPY_LIBRARIES_RELATIVE ${VIGRANUMPY_LIBRARIES_RELATIVE} ${RELPATH})
        else()
            # If ${PATH} is not referring to a path, it is probably a keyword like
            # "optimized" or "debug" (e.g. on the Mac). We then pass it on unchanged.
            set(VIGRANUMPY_LIBRARIES_RELATIVE ${VIGRANUMPY_LIBRARIES_RELATIVE} ${PATH})
        endif()
    endforeach(PATH)

    CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigranumpyConfig.cmake.in
            ${PROJECT_BINARY_DIR}/lib/vigranumpy/CMake/VigranumpyConfig.cmake
            @ONLY IMMEDIATE)
    INSTALL(FILES ${PROJECT_BINARY_DIR}/lib/vigranumpy/CMake/VigranumpyConfig.cmake
            DESTINATION ${VIGRANUMPY_CONFIG_INSTALL_PATH})
ENDIF()

=== src/examples/CMakeLists.txt ===
SET(TARGETS 
    convert
    subimage
    invert
    invert_explicitly
    resize
    smooth
    palette
    profile
    pyramid
    edge
    boundarytensor
    watershed
    weightedWatersheds
    voronoi
    nnlsq
    total_variation)

ADD_CUSTOM_TARGET(examples)

FOREACH(TARGET ${TARGETS})
    ADD_EXECUTABLE(example_${TARGET} EXCLUDE_FROM_ALL ${TARGET}.cxx)
    ADD_DEPENDENCIES(examples example_${TARGET})
    TARGET_LINK_LIBRARIES(example_${TARGET} vigraimpex)
ENDFOREACH(TARGET)

=== src/impex/CMakeLists.txt ===
IF(ZLIB_FOUND)
  ADD_DEFINITIONS(-DHasZLIB)
  INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
ENDIF(ZLIB_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
  INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
ENDIF(PNG_FOUND)

IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
  INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
ENDIF(JPEG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
  INCLUDE_DIRECTORIES(${OPENEXR_INCLUDE_DIR})
ENDIF(OPENEXR_FOUND)

IF(HDF5_FOUND)
  ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
  INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
ENDIF(HDF5_FOUND)

IF (MSVC OR MINGW)
    IF(NOT VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-DVIGRA_DLL)
    ENDIF()
ELSEIF(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)
    IF(VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-fPIC -DPIC)
    ENDIF()
ENDIF ()




ADD_LIBRARY(vigraimpex ${LIBTYPE}
    bmp.cxx
    byteorder.cxx
    codecmanager.cxx
    compression.cxx
    exr.cxx
    gif.cxx
    hdr.cxx
    hdf5impex.cxx
    hdf5_rf_impex.cxx
    iccjpeg.c
    imageinfo.cxx
    jpeg.cxx
    lz4.c
    png.cxx
    pnm.cxx
    rgbe.c
    sifImport.cxx
    sun.cxx
    tiff.cxx
    viff.cxx
    void_vector.cxx)

set(SOVERSION 6)  # increment this after changing the vigraimpex library
IF(MACOSX)
    SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION ${SOVERSION}.${vigra_version}
                         SOVERSION ${SOVERSION} INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ELSE()
    SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION ${SOVERSION}.${vigra_version} SOVERSION ${SOVERSION})
ENDIF()

IF(JPEG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${JPEG_LIBRARIES})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${PNG_LIBRARIES})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${TIFF_LIBRARIES})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${OPENEXR_LIBRARIES})
ENDIF(OPENEXR_FOUND)

IF(HDF5_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${HDF5_LIBRARIES})
ENDIF(HDF5_FOUND)

IF(ZLIB_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${ZLIB_LIBRARIES})
ENDIF(ZLIB_FOUND)


INSTALL(TARGETS vigraimpex
        EXPORT vigra-targets
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib${LIB_SUFFIX}
        ARCHIVE DESTINATION lib${LIB_SUFFIX})

=== test/fourier/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${FFTW3_INCLUDE_DIR})

    VIGRA_CONFIGURE_THREADING()
      
    VIGRA_ADD_TEST(test_fourier test.cxx LIBRARIES vigraimpex ${FFTW3_LIBRARIES} ${THREADING_LIBRARIES})

    VIGRA_COPY_TEST_DATA(ghouse.gif filter.xv gaborresult.xv)
else()
    MESSAGE(STATUS "** WARNING: test_fourier will not be executed")
endif()

=== test/graph_algorithm/CMakeLists.txt ===
VIGRA_ADD_TEST(test_graph_algorithm test.cxx)

=== test/multiarray/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
ENDIF(TIFF_FOUND)

FILE(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/impex)

# Check cpp version
if(NOT ${VIGRA_CPP_VERSION})
    message(FATAL_ERROR 
            "cmake error: VIGRA_CPP_VERSION not defined yet. "
            "Call VIGRA_DETECT_CPP_VERSION() from the main CMakeLists file." )
endif()

# multiarray/test.cxx uses 'auto' from c++11.
string(COMPARE LESS ${VIGRA_CPP_VERSION} "201103" NO_CXX11)
if(NO_CXX11 AND NOT MSVC) # Visual Studio 2010 and 2012 supports enough c++11 features that we can still use it 
    MESSAGE(STATUS "** WARNING: You are compiling in C++98 mode.")
    MESSAGE(STATUS "**          Multiarray tests will be skipped.")
    MESSAGE(STATUS "**          Add -std=c++11 to CMAKE_CXX_FLAGS to enable multiarray tests.")
else()
    VIGRA_ADD_TEST(test_multiarray test.cxx LIBRARIES vigraimpex)
endif()    

# Even with C++11, a working threading implementation is needed for running multiarray_chunked tests.
VIGRA_CONFIGURE_THREADING()

if(NOT THREADING_FOUND)
    MESSAGE(STATUS "** WARNING: Your compiler does not support C++ threading.")
    MESSAGE(STATUS "**          test_multiarray_chunked will not be executed on this platform.")
    if(NOT WITH_BOOST_THREAD)
        MESSAGE(STATUS "**          Try to run cmake with '-DWITH_BOOST_THREAD=1' to use boost threading.")
    endif()
else()
  SET(MULTIARRAY_CHUNKED_LIBRARIES ${THREADING_LIBRARIES})

  IF(HDF5_FOUND)
    ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
    INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
    SET(MULTIARRAY_CHUNKED_LIBRARIES vigraimpex ${HDF5_LIBRARIES} ${MULTIARRAY_CHUNKED_LIBRARIES})
  ELSE(TIFF_FOUND)
    SET(MULTIARRAY_CHUNKED_LIBRARIES vigraimpex ${MULTIARRAY_CHUNKED_LIBRARIES})
  ENDIF()

  VIGRA_ADD_TEST(test_multiarray_chunked test_chunked.cxx 
                 LIBRARIES ${MULTIARRAY_CHUNKED_LIBRARIES})
endif()

=== test/multimorphology/CMakeLists.txt ===
VIGRA_ADD_TEST(test_multimorphology test.cxx LIBRARIES vigraimpex)

=== test/simpleanalysis/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${FFTW3_INCLUDE_DIR})
    ADD_DEFINITIONS(-DHasFFTW3)
    
    VIGRA_ADD_TEST(test_simpleanalysis test.cxx LIBRARIES vigraimpex ${FFTW3_LIBRARIES})
else()
    VIGRA_ADD_TEST(test_simpleanalysis test.cxx LIBRARIES vigraimpex)
endif()

VIGRA_COPY_TEST_DATA(noiseNormalizationTest.xv slantedEdgeMTF.xv lenna128.xv)

=== vigranumpy/test/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${VIGRANUMPY_INCLUDE_DIRS})

SET(TEST_SCRIPTS
    test_arraytypes.py
    test_rf.py
    test_impex.py
    test1.py
    test2.py
    test3.py
    test4.py
    test_color.py
    test_segmentation.py
    test_multidef.py
    )

# setup the file 'testsuccess.cxx' which will become out-of-date when the
# last test failed or when the tests code changed, so that tests are re-executed
SET(TEST_SUCCESS_FILE "${CMAKE_CURRENT_BINARY_DIR}/testsuccess.cxx")

# find the vigranumpy modules that we want to test, and make
# 'testsuccess.cxx' depend on them
# TODO: Does cmake provide a standard way to find those dependencies?
GET_TARGET_PROPERTY(VIGRANUMPY_DEPENDS vigranumpy VIGRA_DEPENDS)
SEPARATE_ARGUMENTS(VIGRANUMPY_DEPENDS)

add_custom_command(
    OUTPUT ${TEST_SUCCESS_FILE}
    DEPENDS ${TEST_SCRIPTS} ${VIGRANUMPY_DEPENDS}
    COMMAND ${CMAKE_COMMAND}
    ARGS -E touch ${TEST_SUCCESS_FILE})

FILE(GLOB TESTSUCCESS_FOUND ${TEST_SUCCESS_FILE})
IF(NOT TESTSUCCESS_FOUND)
    FILE(WRITE ${TEST_SUCCESS_FILE}
     "// auto-generated dummy file to force re-execution of failed tests
")
ENDIF()

# setup the test target
IF(AUTOBUILD_TESTS)
  ADD_LIBRARY(vigranumpytest SHARED
               vigranumpytest.cxx ${TEST_SUCCESS_FILE} ${TEST_SCRIPTS})
ELSE()
  ADD_LIBRARY(vigranumpytest SHARED EXCLUDE_FROM_ALL
               vigranumpytest.cxx ${TEST_SUCCESS_FILE} ${TEST_SCRIPTS})
ENDIF()

IF(PYTHON_PLATFORM MATCHES "^windows$")
    SET_TARGET_PROPERTIES(vigranumpytest PROPERTIES PREFIX "" SUFFIX  ".pyd")
ELSEIF(MACOSX)
    SET_TARGET_PROPERTIES(vigranumpytest PROPERTIES PREFIX "" SUFFIX ".so")
ELSE()
    SET_TARGET_PROPERTIES(vigranumpytest PROPERTIES PREFIX "")
ENDIF()

TARGET_LINK_LIBRARIES(vigranumpytest ${VIGRANUMPY_LIBRARIES})
ADD_DEPENDENCIES(check_python vigranumpytest)
ADD_DEPENDENCIES(ctest vigranumpytest)
ADD_DEPENDENCIES(vigranumpytest vigranumpy)

# setup the file 'set_path.py' to ensure that tests are run against the binaries
# which are currently being built, not against (possibly outdated) installed modules
STRING(REGEX REPLACE "/vigra$" "" VIGRANUMPY_TMP_PATH ${vigranumpy_tmp_dir})
FILE(TO_NATIVE_PATH "${VIGRANUMPY_TMP_PATH}" VIGRANUMPY_TMP_PATH)

if(CMAKE_MAJOR_VERSION LESS 3)
    DEPENDENCY_PATH(VIGRAIMPEX_PATH vigraimpex)
    DEPENDENCY_PATH(VIGRANUMPYTEST_PATH vigranumpytest)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/set_paths.py.cmake2.in
                   ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py
                   @ONLY)
else()
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/set_paths.py.in
                   ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py.in
                   @ONLY)

    # two-stage file configuration is necessary because certain target
    # properties are only known at generation time (policy CMP0026)
    if(MSVC)
        file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py
                      INPUT  ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py.in
                      CONDITION $<CONFIG:Release>)
    else()
        file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py
                      INPUT  ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py.in)
    endif()
endif()

IF(NOT PYTHON_NOSETESTS_NOT_FOUND)
    # copy the individual test scripts
    FOREACH(test_script ${TEST_SCRIPTS})
        ADD_CUSTOM_COMMAND(
            TARGET vigranumpytest
            POST_BUILD
            COMMAND ${CMAKE_COMMAND}
            ARGS -E copy_if_different
            ${CMAKE_CURRENT_SOURCE_DIR}/${test_script} ${CMAKE_CURRENT_BINARY_DIR}/${test_script}
            COMMENT "Running vigranumpy tests")
    ENDFOREACH(test_script)

    VIGRA_NATIVE_PATH(PYTHON_EXECUTABLE ${PYTHON_EXECUTABLE})

    # Windows: Set the DLL path to the binaries currently being built
    #          (so that binaries which are already installed are ignored)
    #          This is not necessary on Linux, because the correct path
    #          is hard-coded into the module by means of 'rpath'
    cmake_policy(PUSH)
    if(POLICY CMP0026)
        # allow 'GET_TARGET_PROPERTY(... LOCATION)'
        cmake_policy(SET CMP0026 OLD)
    endif()
    set(EXTRA_PATH "")
    IF(MSVC)
        SET(PATHSEP ";")
    ELSE()
        SET(PATHSEP ":")
    ENDIF()
    FOREACH(lib ${LIBRARIES})
        if(TARGET ${lib})
            GET_TARGET_PROPERTY(p ${lib} LOCATION)
            if(p)
                GET_FILENAME_COMPONENT(p ${p} PATH)
                VIGRA_NATIVE_PATH(p ${p})
                SET(EXTRA_PATH  "${p}${PATHSEP}${EXTRA_PATH}")
            endif()
        endif()
    ENDFOREACH(lib)
    cmake_policy(POP)

    # Setup the test execution script
    VIGRA_NATIVE_PATH(VIGRA_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
    IF(MSVC OR MINGW)
        get_filename_component(PYTHON_PATH ${PYTHON_EXECUTABLE} PATH)
        get_filename_component(PYTHON_EXE  ${PYTHON_EXECUTABLE} NAME)
        SET(EXTRA_PATH  "${PYTHON_PATH}${PATHSEP}${EXTRA_PATH}")
        SET(VIGRA_TEST_EXECUTABLE "${PYTHON_EXE} -c \"import nose; nose.main()\" . %CONFIGURATION%")
        SET(VIGRA_TEST_SCRIPT     "${CMAKE_CURRENT_BINARY_DIR}/run_vigranumpytest.bat")
        CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config/run_test.bat.in
                       ${VIGRA_TEST_SCRIPT}
                       @ONLY)
    ELSE()
        SET(VIGRA_TEST_EXECUTABLE "${PYTHON_EXECUTABLE} -c \"import nose; nose.main()\" .")
        SET(VIGRA_TEST_SCRIPT     "${CMAKE_CURRENT_BINARY_DIR}/run_vigranumpytest.sh")
        CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config/run_test.sh.in
                       ${VIGRA_TEST_SCRIPT}
                       @ONLY)
        EXECUTE_PROCESS(COMMAND chmod u+x ${VIGRA_TEST_SCRIPT} OUTPUT_QUIET ERROR_QUIET)
    ENDIF()

    # register the test execution command
    # VIGRA_CONFIGURATION is 'release' or 'debug' on Windows, nothing on Linux
    # variable CMAKE_CFG_INTDIR contains a dot '.' for a Windows nmake build, or
    #                           '$(OutDir)' for a VisualStudio build (OutDir will be
    #                           set by VS at build time)
    IF(NOT CMAKE_CFG_INTDIR STREQUAL ".")
        SET(VIGRA_CONFIGURATION ${CMAKE_CFG_INTDIR})
    ELSE()
        SET(VIGRA_CONFIGURATION)
    ENDIF()

    IF(AUTOEXEC_TESTS)
        add_custom_command(
            TARGET vigranumpytest
            POST_BUILD
            COMMAND ${VIGRA_TEST_SCRIPT} ARGS ${VIGRA_CONFIGURATION}
            COMMENT "Running vigranumpy tests")
    ENDIF()

    ADD_TEST(vigranumpytest ${VIGRA_TEST_SCRIPT} ${VIGRA_CONFIGURATION})

    # if we configure for Visual Studio, setup the debug command
    if(MSVC AND NOT (MSVC_VERSION VERSION_LESS "11"))
        # FIXME: this may not portable between VC versions (works for 11.0 - 14.0)
        set(VIGRA_TEST_EXE "${PYTHON_EXECUTABLE}")
        set(VIGRA_TEST_ARGS "-c \"import nose; nose.main()\" . \$(Configuration)")
        configure_file(${CMAKE_SOURCE_DIR}/config/testdebug.vcxproj.user.in
                       ${CMAKE_CURRENT_BINARY_DIR}/vigranumpytest.vcxproj.user
                       @ONLY)
    endif()
ELSE()
        MESSAGE(STATUS "  vigranumpy tests will NOT be executed (nosetests missing)")
ENDIF()

=== test/classifier/data/CMakeLists.txt ===

#       message(status "Current Source: ${CMAKE_CURRENT_SOURCE_DIR}") 
#       message(status "Current Bin: ${CMAKE_CURRENT_BINARY_DIR}") 
#       configure_file(${CMAKE_CURRENT_SOURCE_DIR}/oldClassifier.log 
#                      ${CMAKE_CURRENT_BINARY_DIR}/oldClassifier.log
#                      COPYONLY)
VIGRA_COPY_TEST_DATA(oldClassifier.log oldsetTest.log empty.hdf5 bare.hdf5)

=== debian/changelog ===
libvigraimpex (1.10.0+git20160211.167be93+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Replace sphinx.ext.pngmath by sphinx.ext.imgmath
    Closes: #923467

 -- Andreas Tille <tille@debian.org>  Fri, 08 Mar 2019 18:40:38 +0100

libvigraimpex (1.10.0+git20160211.167be93+dfsg1-1) unstable; urgency=medium

  * Repackaged upstream tarball.
  * deb/changelog:
    + remove a trailing line.
  * deb/control:
    + bump standards to 4.3.0.
    + drop ancient X-Python-Version field.
  * deb/copyright:
    + exclude src/images/dissolved.gif (another "lenna" image).
    + exclude docsrc/vigra-wiki.html (not included in docs package).
  * deb/rules:
    + drop obsolete DEB_BUILD_OPTIONS export line.
    + don't evaluate DEB_BUILD_ARCH manually, but include architecture.mk.
  * deb/python-vigra-doc.doc-base:
    + fix Text paragraph for doc-base-file-references-missing-file.
  * bump debhelper level to 10 (changes in d/control and d/compat).

 -- Daniel Stender <stender@debian.org>  Thu, 27 Dec 2018 22:30:27 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Daniel Stender <stender@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 9),
+ debhelper (>= 10),
  dh-python,
  dpkg-dev (>= 1.15.3~),
  libboost-python-dev (>= 1.40.0),
@@ -28,8 +28,7 @@
  texlive-latex-base
 Build-Conflicts:
  autoconf2.13
-X-Python-Version: >= 2.5
-Standards-Version: 3.9.7
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/science-team/libvigraimpex
 Vcs-Git: https://salsa.debian.org/science-team/libvigraimpex.git
 Homepage: http://ukoethe.github.io/vigra/

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
-#export DEB_BUILD_OPTIONS=nocheck
 
+include /usr/share/dpkg/architecture.mk
 CFLAGS := $(shell env DEB_CFLAGS_MAINT_APPEND=-pipe dpkg-buildflags --get CFLAGS; dpkg-buildflags --get CPPFLAGS)
 CXXFLAGS := $(shell env DEB_CXXFLAGS_MAINT_APPEND=-pipe dpkg-buildflags --get CXXFLAGS; dpkg-buildflags --get CPPFLAGS)
 LDFLAGS := $(shell env DEB_LDFLAGS_MAINT_APPEND='-Wl,--as-needed -Wl,-z,now' dpkg-buildflags --get LDFLAGS)
@@ -23,8 +23,6 @@
   CMAKE_EXTRAS := -DWITH_BOOST_THREAD=1
   CXXFLAGS += -std=c++11 # not set by VigraDetectThreading.cmake
 endif
-
-DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
 ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
   CXXFLAGS += --param ggc-min-expand=20
